<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Float-point Detection</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Float-point Detection</div>  </div>
</div><!--header-->
<div class="contents">

<p>The CFAR detection algorithm based on floating point input signal.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga5a5916099535483238f51f9c1cd720af"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___d_e_t_e_c_t___f_l_o_a_t.html#ga5a5916099535483238f51f9c1cd720af">mmwavelib_cfarfloat_caall</a> (float32_t *InputPower, uint32_t fftSize, uint8_t cfarType, uint32_t guardLen, uint32_t searchLen, uint32_t leftSkipLen, uint32_t rightSkipLen, float32_t relThr, uint32_t *index, float32_t *noise)</td></tr>
<tr class="memdesc:ga5a5916099535483238f51f9c1cd720af"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_cfarfloat_caall.  <a href="#ga5a5916099535483238f51f9c1cd720af">More...</a><br /></td></tr>
<tr class="separator:ga5a5916099535483238f51f9c1cd720af"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga06b9015818cdec6cbb80ec4a8d83feca"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___d_e_t_e_c_t___f_l_o_a_t.html#ga06b9015818cdec6cbb80ec4a8d83feca">mmwavelib_cfarfloat_caall_opt</a> (float32_t *InputPower, uint32_t fftSize, uint8_t cfarType, uint32_t guardLen, uint32_t searchLen, uint32_t leftSkipLen, uint32_t rightSkipLen, float32_t relThr, uint32_t *index, float32_t *noise)</td></tr>
<tr class="memdesc:ga06b9015818cdec6cbb80ec4a8d83feca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_cfarfloat_caall_opt.  <a href="#ga06b9015818cdec6cbb80ec4a8d83feca">More...</a><br /></td></tr>
<tr class="separator:ga06b9015818cdec6cbb80ec4a8d83feca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga53beb5edbff17982d346ad0a282ac485"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___d_e_t_e_c_t___f_l_o_a_t.html#ga53beb5edbff17982d346ad0a282ac485">mmwavelib_cfarfloat_wrap</a> (float32_t *InputPower, uint32_t fftSize, uint8_t cfarType, uint32_t guardLen, uint32_t searchLen, float32_t relThr, uint32_t *index, float32_t *noise)</td></tr>
<tr class="memdesc:ga53beb5edbff17982d346ad0a282ac485"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_cfarfloat_wrap.  <a href="#ga53beb5edbff17982d346ad0a282ac485">More...</a><br /></td></tr>
<tr class="separator:ga53beb5edbff17982d346ad0a282ac485"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5d7f5345ed1ae1176c909af7ef4d7452"><td class="memItemLeft" align="right" valign="top">uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___d_e_t_e_c_t___f_l_o_a_t.html#ga5d7f5345ed1ae1176c909af7ef4d7452">mmwavelib_cfarfloat_wrap_opt</a> (float32_t *InputPower, uint32_t fftSize, uint8_t cfarType, uint32_t guardLen, uint32_t searchLen, float32_t relThr, uint32_t *index, float32_t *noise)</td></tr>
<tr class="memdesc:ga5d7f5345ed1ae1176c909af7ef4d7452"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_cfarfloat_wrap_opt.  <a href="#ga5d7f5345ed1ae1176c909af7ef4d7452">More...</a><br /></td></tr>
<tr class="separator:ga5d7f5345ed1ae1176c909af7ef4d7452"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab3746e8cdadf6f7abd04a8f6a65dc786"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___m_m_w_a_v_e_l_i_b___d_e_t_e_c_t___f_l_o_a_t.html#gab3746e8cdadf6f7abd04a8f6a65dc786">mmwavelib_cfarfloat_point</a> (float32_t *InputPower, uint32_t fftSize, uint8_t cfarType, uint32_t guardLen, uint32_t searchLen, float32_t relThr, uint32_t index, float32_t *noise)</td></tr>
<tr class="memdesc:gab3746e8cdadf6f7abd04a8f6a65dc786"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function Name : mmwavelib_cfarfloat_point.  <a href="#gab3746e8cdadf6f7abd04a8f6a65dc786">More...</a><br /></td></tr>
<tr class="separator:gab3746e8cdadf6f7abd04a8f6a65dc786"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>The CFAR detection algorithm based on floating point input signal. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ga5a5916099535483238f51f9c1cd720af"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t mmwavelib_cfarfloat_caall </td>
          <td>(</td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>InputPower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>cfarType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>guardLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>searchLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>leftSkipLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>rightSkipLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>relThr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>noise</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_cfarfloat_caall. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Performs a regular Cell Averaging (CFAR-CA), Cell Accumulation (CFAR-CACC), Cell SO (CFAR-SO), and Cell GO CFAR (CFAR-GO) based on floating point signal power. The first CUT index is leftSkipLen. and its left noise samples are the samples from leftSkipLen+guardLen to leftSkipLen+guardLen+guardLen+searchLen- 1. The last CUT index is fftSize-leftSkipLen, and its right noise samples are the samples from fftSize-rightSkipLen-guardLen-searchLen-rightSkipLen to fftSize-rightSkipLen-rightSkipLen -1.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">InputPower</td><td>: input signal power array (floating point) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize</td><td>: number of elements in the InputPower </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cfarType</td><td>: 0-CFAR-CA, 1-CFAR-CAGO, 2-CFAR-SO, 3-CFAR-CACC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">guardLen</td><td>: one sided guard length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">searchLen</td><td>: one sided search length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">leftSkipLen</td><td>: number of samiples to be skipped on the left side in the search array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">rightSkipLen</td><td>: number of samiples to be skipped on the right side in the search array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">relThr</td><td>: the relative threshold between noise power and signal power. if signal power is greater then relThr*noisepower, declare a peak </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">index</td><td>: output array with indices of the detected peaks </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">noise</td><td>: output array with the noise power for every detected peaks, it is the noise power used in the CFAR detection. If it is the CFAR-CA, the noise power is the average power for all the samples in the two-sides search window. if it is CFAR-CACC, the noise power is the sum of the powers for the samples in the two sides search window, if it is CFAR-SO, it is the minimum average power between samples in the two sides search window, if it is CFAR-GO, it is the maximum average power between samples in the two sides search window.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Number of detected peaks (i.e length of out)</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd></dd></dl>
<p>cycles 8.40*fftsize + 677 (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga06b9015818cdec6cbb80ec4a8d83feca"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t mmwavelib_cfarfloat_caall_opt </td>
          <td>(</td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>InputPower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>cfarType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>guardLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>searchLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>leftSkipLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>rightSkipLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>relThr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>noise</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_cfarfloat_caall_opt. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Performs a regular Cell Averaging, Cell Accumulation, SO, and GO CFAR based on floating point signal power same as function mmwavelib_cfarfloat_caall, but with less cycles, and the detected peaks are not in ascending order.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">InputPower</td><td>: input signal power array (floating point) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize</td><td>: number of elements in the InputPower </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cfarType</td><td>: 0-CFAR-CA, 1-CFAR-GO, 2-CFAR-SO, 3-CFAR-CACC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">guardLen</td><td>: one sided guard length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">searchLen</td><td>: one sided search length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">leftSkipLen</td><td>: number of samiples to be skipped on the left side in the search array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">rightSkipLen</td><td>: number of samiples to be skipped on the right side in the search array </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">relThr</td><td>: the relative threshold between noise power and signal power. if signal power is greater then relThr*noisepower, declare a peak </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">index</td><td>: output array with indices of the detected peaks </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">noise</td><td>: output array with the noise power for every detected peaks, it is the noise power used in the CFAR detection. If it is the CFAR-CA, the noise power is the average power for all the samples in the two-sides search window. if it is CFAR-CACC, the noise power is the sum of the powers for the samples in the two sides search window, if it is CFAR-SO, it is the minimum average power between samples in the two sides search window, if it is CFAR-GO, it is the maximum average power between samples in the two sides search window.<ul>
<li></li>
</ul>
</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Number of detected peaks (i.e length of out)</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd></dd></dl>
<p>cycles 4.49*fftsize+981 (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="gab3746e8cdadf6f7abd04a8f6a65dc786"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t mmwavelib_cfarfloat_point </td>
          <td>(</td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>InputPower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>cfarType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>guardLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>searchLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>relThr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>noise</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_cfarfloat_point. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Performs single CUT CFAR detection using Cell Averaging, Cell Accumulation, Cell SO, or Cell GO CFAR based on floating point signal power.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">InputPower</td><td>: input signal power array (floating point) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize</td><td>: number of elements in the InputPower </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cfarType</td><td>: 0-CFAR-CA, 1-CFAR-GO, 2-CFAR-SO, 3-CFAR-CACC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">guardLen</td><td>: one sided guard length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">searchLen</td><td>: one sided search length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">relThr</td><td>: the relative threshold between noise power and signal power. if signal power is greater then relThr*noisepower, declare a peak </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">index</td><td>: the detected element index in the InputPower array </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">noise</td><td>: output noise power for the detected index</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if it is a peak, 0 if not a peak</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd></dd></dl>
<p>cycles 540 (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga53beb5edbff17982d346ad0a282ac485"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t mmwavelib_cfarfloat_wrap </td>
          <td>(</td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>InputPower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>cfarType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>guardLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>searchLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>relThr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>noise</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_cfarfloat_wrap. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Performs a regular Cell Averaging, Cell Accumulation, Cell SO, and Cell GO CFAR based on floating point signal power. The noise samples for the cell at the edges are the wrap around samples.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">InputPower</td><td>: input signal power array (floating point) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize</td><td>: number of elements in the InputPower </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cfarType</td><td>: 0-CFAR-CA, 1-CFAR-GO, 2-CFAR-SO, 3-CFAR-CACC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">guardLen</td><td>: one sided guard length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">searchLen</td><td>: one sided search length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">relThr</td><td>: the relative threshold between noise power and signal power. if signal power is greater then relThr*noisepower, declare a peak </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">index</td><td>: output array with indices of the detected peaks </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">noise</td><td>: output array with the noise power for every detected peaks, it is the noise power used in the CFAR detection. If it is the CFAR-CA, the noise power is the average power for all the samples in the two-sides search window. if it is CFAR-CACC, the noise power is the sum of the powers for the samples in the two sides search window, if it is CFAR-SO, it is the minimum average power between samples in the two sides search window, if it is CFAR-GO, it is the maximum average power between samples in the two sides search window.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Number of detected peaks (i.e length of out)</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd></dd></dl>
<p>cycles 8.02*fftSize + 604 (cgt 8.1.3) </p>

</div>
</div>
<a class="anchor" id="ga5d7f5345ed1ae1176c909af7ef4d7452"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint32_t mmwavelib_cfarfloat_wrap_opt </td>
          <td>(</td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>InputPower</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>fftSize</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>cfarType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>guardLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>searchLen</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t&#160;</td>
          <td class="paramname"><em>relThr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&#160;</td>
          <td class="paramname"><em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float32_t *&#160;</td>
          <td class="paramname"><em>noise</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function Name : mmwavelib_cfarfloat_wrap_opt. </p>
<hr/>
 <dl class="section user"><dt></dt><dd><b>Description</b> : Performs a regular Cell Averaging, Cell Accumulation, Cell SO, and Cell GO CFAR based on floating point signal power, same as mmwavelib_cfarfloat_wrap, but with less cycles, and the detected peaks are not in ascending order.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">InputPower</td><td>: input signal power array (floating point) </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">fftSize</td><td>: number of elements in the InputPower </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">cfarType</td><td>: 0-CFAR-CA, 1-CFAR-GO, 2-CFAR-SO, 3-CFAR-CACC </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">guardLen</td><td>: one sided guard length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">searchLen</td><td>: one sided search length </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">relThr</td><td>: the relative threshold between noise power and signal power. if signal power is greater then relThr*noisepower, declare a peak </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">index</td><td>: output array with indices of the detected peaks </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">noise</td><td>: output array with the noise power for every detected peaks, it is the noise power used in the CFAR detection. If it is the CFAR-CA, the noise power is the average power for all the samples in the two-sides search window. if it is CFAR-CACC, the noise power is the sum of the powers for the samples in the two sides search window, if it is CFAR-SO, it is the minimum average power between samples in the two sides search window, if it is CFAR-GO, it is the maximum average power between samples in the two sides search window.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Number of detected peaks (i.e length of out)</dd></dl>
<dl class="section pre"><dt>Precondition</dt><dd></dd></dl>
<p>cycles 4.54*fftSize + 965 (cgt 8.1.3) </p>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
